/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
const token = '9uP6cj-w6UOk2guFssVdxuzWbmt_garilE2WSedY:DSZcSq-DBDHL4iUhjmtbCcqDv6I=:eyJpbnNlcnRPbmx5IjoxLCJzY29wZSI6ImFzc2V0cyIsIm1pbWVMaW1pdCI6ImFwcGxpY2F0aW9uL3BkZjtpbWFnZS8qO3ZpZGVvLyo7YXVkaW8vKiIsImRlYWRsaW5lIjoxNTI5NDg5ODAwfQ==';
var app = {
    // Application Constructor
    initialize: function() {
        document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
    },

    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.
    onDeviceReady: function() {
        this.receivedEvent('deviceready');
    },

    // Update DOM on a Received Event
    receivedEvent: function(id) {
        var parentElement = document.getElementById(id);
        var listeningElement = parentElement.querySelector('.listening');
        var receivedElement = parentElement.querySelector('.received');

        listeningElement.setAttribute('style', 'display:none;');
        receivedElement.setAttribute('style', 'display:block;');

        console.log('Received Event: ' + id);

        document.getElementById('s666').onclick = function () {
            navigator.notification.alert(
                'You are the winner!',  // message
                function () {
                    alert('click 666');
                    // var url = 'https://yongling8808.github.io/test/video_demo/video.html';
                    var url = 'http://192.168.0.103:8000/';
                    var target = '_blank';
                    var options = 'location=yes';
                    cordova.InAppBrowser.open(url, target, options);
                },                      // callback
                'Game Over',            // title
                'Done'                  // buttonName
            );
        };
        document.getElementById('s888').onclick = function () {
            var url = 'https://www.baidu.com';
            var target = '_blank';
            var options = 'title=HAHA';
            cordova.InAppBrowser.open(url, target, options);
        };

        var _this = this;
        document.getElementById("recordm").onclick = function(){
            _this.imageCapture();
        }
        document.getElementById("recorda").onclick = function(){
            _this.audioCapture();
        }
        document.getElementById("recordv").onclick = function(){
            _this.videoCapture();
        }
        document.getElementById("selectv").onclick = function(){
            _this.mediaPicker();
        }
    },

    imageCapture: function() {
        navigator.device.capture.captureImage(
            function (mediaFiles) {
                var i, len;
                for (i = 0, len = mediaFiles.length; i < len; i += 1) {
                    var path = mediaFiles[i].fullPath;
                    path = decodeURIComponent(path);
                    var localURL = mediaFiles[i].localURL;
                    localURL = decodeURIComponent(localURL);
                    alert("录制成功！\n\n"
                        + "文件名：" + mediaFiles[i].name + "\n"
                        + "大小：" + mediaFiles[i].size + "\n\n"
                        + "localURL地址：" + localURL + "\n\n"
                        + "fullPath地址：" + path);

                    const media = {
                        quality: 30,
                        mediaType: "image",
                        path: path.substring(7)
                    };
                    MediaPicker.compressImage(media, function(compressData) {
                        alert(compressData.path + ': ' + compressData.size);
                    }, function(e) {
                        alert(e);
                    });
                }
            },
            function (error) {
                alert('录制失败！错误码：' + error.code)
            },
            {
                limit: 1
            }
        );
    },

    audioCapture: function() {
        // 开始录音（最长录制时间：10秒）
        navigator.device.capture.captureAudio(
            onSuccess,
            onError,
            {
                limit: 1,
                duration: 10
            }
        );

        // 录制成功
        function onSuccess(mediaFiles) {
            var i, len;
            // 遍历获取录制的文件
            // 注意：iOS只支持一次录制一个视频或音频
            for (i = 0, len = mediaFiles.length; i < len; i += 1) {
                console.log(mediaFiles[i]);
                var path = mediaFiles[i].fullPath;
                path = decodeURIComponent(path);
                var localURL = mediaFiles[i].localURL;
                localURL = decodeURIComponent(localURL);
                alert("录制成功！\n\n"
                    + "文件名：" + mediaFiles[i].name + "\n"
                    + "大小：" + mediaFiles[i].size + "\n\n"
                    + "localURL地址：" + localURL + "\n\n"
                    + "fullPath地址：" + path);

                cordova.plugin.http.uploadFile("http://up.qiniu.com", {
                    key: mediaFiles[i].name,
                    token,
                }, {}, path, 'file', function(response) {
                    alert(response.status);
                }, function(response) {
                    alert(response.error);
                });
            }
        }

        //录制失败
        function onError(error) {
            alert('录制失败！错误码：' + error.code);
        }
    },

    videoCapture: function() {
        //开始录像（最长录制时间：10秒）
        navigator.device.capture.captureVideo(
            onSuccess,
            onError,
            {
                limit: 1,
                duration: 10
            }
        );

        //录制成功
        function onSuccess(mediaFiles) {
            var i, path, len;
            for (i = 0, len = mediaFiles.length; i < len; i += 1) {
                path = mediaFiles[i].fullPath;
                alert("录制成功！\n\n"
                    + "文件名：" + mediaFiles[i].name + "\n"
                    + "大小：" + mediaFiles[i].size + "\n\n"
                    + "localURL地址：" + mediaFiles[i].localURL + "\n\n"
                    + "fullPath地址：" + path);

                var name = mediaFiles[i].name;
                var fullDir = path.substring(0, path.lastIndexOf('/'));

                VideoEditor.transcodeVideo(
                    videoTranscodeSuccess,
                    (err) => { alert('videoTranscodeError, err: ' + err) },
                    {
                        fileUri: path,
                        outputFileName: 'ht' + name.split('.')[0],
                        outputFileType: VideoEditorOptions.OutputFileType.MPEG4,
                        optimizeForNetworkUse: VideoEditorOptions.OptimizeForNetworkUse.YES,
                        saveToLibrary: true,
                        maintainAspectRatio: true,
                        width: 640,
                        height: 640,
                        videoBitrate: 1800000, // 1 megabit
                        audioChannels: 2,
                        audioSampleRate: 44100,
                        audioBitrate: 128000, // 128 kilobits
                        progress: function(info) {}
                    }
                );

                function videoTranscodeSuccess(result) {
                    cordova.plugin.http.uploadFile("http://up.qiniu.com", {
                        key: name,
                        token,
                    }, {}, 'file://' + result, 'file', function(response) {
                        alert(response.status);
                    }, function(response) {
                        alert(response.error);
                    });

                    deleteFile(fullDir, name);
                }
            }
        }

        //录制失败
        function onError(error) {
            alert('录制失败！错误码：' + error.code);
        }

        function deleteFile(path, filename) {
            window.resolveLocalFileSystemURL(path, function(dir) {
                dir.getFile(filename, {create:false}, function(fileEntry) {
                    fileEntry.remove(function(){
                    },function(error){
                    });
                });
            });
        }
    },

    mediaPicker: function() {
        var args = {
            'selectMode': 100, //101=picker image and video , 100=image , 102=video
            'maxSelectCount': 4, //default 40 (Optional)
            'maxSelectSize': 18874368, //188743680=180M (Optional)
        };

        MediaPicker.getMedias(args, function(medias) {
            alert(medias.length);
        }, function(e) { console.log(e) })
    }
};

app.initialize();